using System;
using System.Collections.Generic;

namespace ValidationFramework
{
    public class Account
    {
        private readonly IList<IRule> m_validationRules = new List<IRule>();

        public Account()
        {
            Created = DateTime.Now;
            Address = string.Empty;
        }

        public DateTime Created { set; get; }
        public string Address { get; set; }
        public bool Activated { get; set; }
        public bool IsValidated { get; set; }
        
        public void AddValidationRule(IRule rule)
        {
            m_validationRules.Add(rule);
        }

        public void SetValidationSpecification(IValidationSpecification specification)
        {
            foreach (IRule rule in specification.GetValidationRules())
                m_validationRules.Add(rule);
        }
        //StatePattern:eine ValidationSpecification als Property per SetterInjection setzen und die nach den Rules fragen
        public IEnumerable<IRule> GetBrokenRules()
        {
            SetupValidationRules();
            return RuleBase.CollectBrokenRules(m_validationRules);
        }
        private void SetupValidationRules()
        {
            //foreach(IRule rule in ValidationSpecificationFactory.Create<Account>(this).GetValidationRules())
            //    m_validationRules.Add(rule);
        }

    }
}